/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "interface.h"
#include "support.h"
#include "math.h"
#include "main.h"

float INITIAL_XMAX=5.0, INITIAL_XMIN=-5.0, INITIAL_YMAX=4.0, INITIAL_YMIN=-4.0;
float MOVE_FRACTION_X = 0.05;
float MOVE_FRACTION_Y = 0.05;
float SCREEN_FRACTION_X = 0.1;
float SCREEN_FRACTION_Y = 0.1;

guchar rgbbuf[WIDTH * HEIGHT * STEP];

GtkWidget *mainWindow;
GtkWidget *darea;

float xmax_queue[POINT_BUF_LENGTH];
float xmin_queue[POINT_BUF_LENGTH];
float ymax_queue[POINT_BUF_LENGTH];
float ymin_queue[POINT_BUF_LENGTH];
int points;

float xpixel, ypixel;

gboolean expose_event(GtkWidget *widget, GdkEvent *event, gpointer data);
gboolean tick_event(gpointer data);

gint flameCount=0;

float xmin, xmax, ymin, ymax, t_xmin, t_xmax, t_ymin, t_ymax;
float p_xmin, p_xmax, p_ymin, p_ymax;

int
main (int argc, char *argv[])
{
  srandom(time(NULL));
  gnome_init ("gnofractroam", VERSION, argc, argv);
  gdk_rgb_init();

  mainWindow = create_mainWindow ();
  darea = gtk_drawing_area_new();
  gtk_drawing_area_size(GTK_DRAWING_AREA (darea), WIDTH, HEIGHT);
  gtk_container_add(GTK_CONTAINER(mainWindow),darea);
  gtk_signal_connect(GTK_OBJECT(darea), "expose-event", GTK_SIGNAL_FUNC(expose_event),NULL);
  gtk_widget_show_all (mainWindow);
  
  init();

  gtk_timeout_add(UPDATE,tick_event,NULL);

  gtk_main ();
  return 0;
}

int count(int x, int y) {
  float z=0, zi=0, z_2=0, zi_2=0, zprev, c, ci;
  int n;
  c = xmin+x*xpixel;
  ci = ymin+y*ypixel;
  //for (n=0;n<256 && z < 2;n++) { // not the "proper" but NIFTY artifacts
  for (n=0;n<256 && (z_2 + zi_2) < 4;n++) {
    zprev=z;
    z_2=z*z;
    zi_2=zi*zi;
    z = z_2 - zi_2 + c;
    zi= 2 * zprev * zi + ci;
  }
  return n;
}

void init() {
  xmin = INITIAL_XMIN; xmax = INITIAL_XMAX;
  ymin = INITIAL_YMIN; ymax = INITIAL_YMAX;
  xpixel = (xmax-xmin)/WIDTH;
  ypixel = (ymax-ymin)/HEIGHT;
  t_xmax=xmax;
  t_xmin=xmin;
  t_ymax=ymax;
  t_ymin=ymin;
  p_xmax=xmax*2;
  p_xmin=xmin*2;
  p_ymax=ymax*2;
  p_ymin=ymin*2;
  plot_picture();
}

void plot_picture() {
  gint x, y;
  guchar *pos;
  int temp;
  pos = rgbbuf;
  
  for (y = 0; y < HEIGHT; y++) {
    for (x = 0; x < WIDTH; x++) {
      temp=count(x,y)*4;
      *pos++ = temp;
      *pos++ = 256-temp;
      *pos++ = 256 % temp;
    }
  }
}

int iscomplex(int point) {
  int x = point % WIDTH;
  int y = point / WIDTH;
  int up,left,right,down,upleft,upright,downleft,downright,center;
  center = rgbbuf[(x+(WIDTH*y))*STEP];
  if (center > THRESH) {
    up = rgbbuf[(x+WIDTH*(y+1))*STEP];
    down = rgbbuf[(x+WIDTH*(y-1))*STEP];
    left = rgbbuf[(x-1+WIDTH*y)*STEP];
    right = rgbbuf[(x+1+WIDTH*y)*STEP];
    upleft = rgbbuf[(x-1+WIDTH*(y+1))*STEP];
    downleft = rgbbuf[(x-1+WIDTH*(y-1))*STEP];
    upright = rgbbuf[(x+1+WIDTH*(y+1))*STEP];
    downright = rgbbuf[(x+1+WIDTH*(y-1))*STEP];
    return (center != up && center != down && center != left && center != right && center != upleft && center != downleft && center != upright && center != downright && upleft != upright && upleft != downleft && upright != downright);
  }
  return 0;
}

void paint_picture(){
  gdk_draw_rgb_image (darea->window, darea->style->fg_gc[GTK_STATE_NORMAL], 0, 0, WIDTH,HEIGHT, GDK_RGB_DITHER_NONE, rgbbuf, WIDTH * STEP);
}

void update() {
  float xbound, ybound;
  static float lastxpixel, lastypixel;
  static int outercount=0;
  float point1x=0, point1y=0, point2x=0, point2y=0;
  float width,height;
  int x, y, point, mycount=0;
  int forcePop=0;
  int forceNoPop=0;
  width=xmax-xmin;
  height=ymax-ymin;
  xpixel = width/WIDTH;
  ypixel = height/HEIGHT;
  xbound = fabs(xpixel) * BOUND;
  ybound = fabs(ypixel) * BOUND;


  if ( lastxpixel == xpixel || lastypixel == ypixel //case 1 - a pixel is 0.0f wide, we're not going to get anywhere. fast.
       || (t_xmax == t_xmin || t_ymax == t_ymin)//case 2 - our target is too small
       || p_xmin == xmin || p_xmax == xmax || p_ymin == ymin || p_ymax == ymax // case 3 -- we don't seem to be getting anywhere
     ) {
    forcePop=1;
  }
  if (points > 0 && (xmax_queue[points-1] == 0 && xmin_queue[points-1] == 0)) {
    forceNoPop=1;
  }
  //if we're within BOUND pixels for xmax, xmin, ymax, ymin -- pick a point
  if (forcePop || (fabs(xmax-t_xmax) < xbound && fabs(xmin-t_xmin) < xbound && fabs(ymax-t_ymax) < ybound && fabs(ymin-t_ymin) < ybound)) {
    //if we gotta, we gotta
    if (forcePop) {
printf("FORCEPOP\n");
      points=0;
      t_xmax = INITIAL_XMAX;
      t_xmin = INITIAL_XMIN;
      t_ymax = INITIAL_YMAX;
      t_ymin = INITIAL_YMIN;
    //if there is anything on the queue, 50/50 to pick off it
    } else if ((points > 0 && ((double)random()/RAND_MAX) > .5)){
printf("POP\n");
      points--;
      t_xmax = xmax_queue[points];
      t_xmin = xmin_queue[points];
      t_ymax = ymax_queue[points];
      t_ymin = ymin_queue[points];
    //take random samples until two points are above threshold
    } else {
printf("picking a new point because we're at: \n");
printf("width: %.11e, height: %.11e\n",width,height);
printf("pix[%.11e,%.11e,%.11e,%.11e]\n",lastxpixel,xpixel,lastypixel,ypixel);
printf("now[%.11e,%.11e,%.11e,%.11e]\n",xmin,xmax,ymin,ymax);
printf("tar[%.11e,%.11e,%.11e,%.11e]\n",t_xmin,t_xmax,t_ymin,t_ymax);
      while (point2y == 0 && mycount < MAXCOUNT) {
        point = (int) fabs(((double)random()/RAND_MAX) * WIDTH * HEIGHT);
        mycount++;
        if (iscomplex(point)) {
          x = point % WIDTH;
          y = point / WIDTH;
          if (point1y == 0) {
            point1x = xmin + x * xpixel;
            point1y = ymin + y * ypixel;
          } else {
            point2x = xmin + x * xpixel;
            point2y = ymin + y * ypixel;
          }
        }
      }
      //set target bounds to bound that point as center
      //using SCREEN_FRACTION_X/Y
      if (mycount < MAXCOUNT) {
        t_xmax = point1x + width*(SCREEN_FRACTION_X/2);
        t_xmin = point1x - width*(SCREEN_FRACTION_X/2);
        t_ymax = point1y + height*(SCREEN_FRACTION_Y/2);
        t_ymin = point1y - height*(SCREEN_FRACTION_Y/2);
        xmax_queue[points] = point2x + width*(SCREEN_FRACTION_X/2);
        xmin_queue[points] = point2x - width*(SCREEN_FRACTION_X/2);
        ymax_queue[points] = point2y + height*(SCREEN_FRACTION_Y/2);
        ymin_queue[points] = point2y - height*(SCREEN_FRACTION_Y/2);
        points++;
      } else {
        //we're not able to find anything interesting, let's start over...
        points=0;
        t_xmax = INITIAL_XMAX;
        t_xmin = INITIAL_XMIN;
        t_ymax = INITIAL_YMAX;
        t_ymin = INITIAL_YMIN;
      }
printf("tar[%.11e,%.11e,%.11e,%.11e]\n\n",t_xmin,t_xmax,t_ymin,t_ymax);
    }
outercount=0;
  }
  //move MOVE_FRACTION_X/Y
  p_xmax = xmax; p_xmin = xmin; p_ymax = ymax; p_ymin = ymin;
  xmax += (t_xmax - xmax)* MOVE_FRACTION_X;
  xmin += (t_xmin - xmin)* MOVE_FRACTION_X;
  ymax += (t_ymax - ymax)* MOVE_FRACTION_Y;
  ymin += (t_ymin - ymin)* MOVE_FRACTION_Y;
  lastxpixel=xpixel;
  lastypixel=ypixel;
  outercount++;
  if (outercount > 200) {
printf("stuck!?\n");    
printf("width: %.11e, height: %.11e\n",width,height);
printf("pix[%.11e,%.11e,%.11e,%.11e]\n",lastxpixel,xpixel,lastypixel,ypixel);
printf("now[%.11e,%.11e,%.11e,%.11e]\n\n",xmin,xmax,ymin,ymax);
  }
}

gboolean expose_event(GtkWidget *widget, GdkEvent *event, gpointer data) {
  paint_picture();
  return TRUE;
}

gboolean tick_event(gpointer data) {
  plot_picture();
  paint_picture();
  update();
  return TRUE;
}
